//#include "clist.h"
//#include "ccar.h"
//#include "ccross.h"
#include "ccontrol.h"
//#include "cprobe.h"
//#include "cstreet.h"
#include <graphics.h>

extern CControl C;
extern CProbe P;
extern CList<CStreet> LS; //list of streets

void CCar::Trans(){//sets transitions
  mv=mv+ma;//apply acceleration to velocity (even if a=0)
  switch (mdir){
    case 0:my=my-mv;break;
    case 3:mx=mx+mv;break;
    case 6:my=my+mv;break;
    case 9:mx=mx-mv;break;
  }

  //this next 4 ifs make the streets cyclic
/*  if (mx>12800) mx=0;
  if (my>7000) my=0;
  if (mx<0) mx=12800;
  if (my<0) my=7000;
*/
}

void CCar::Draw(int color){
  int x=(mx+P.GetX())/P.GetSc(),y=(my+P.GetY())/P.GetSc();
  int tc;//turn color
  if (color!=0)
    setcolor(mcolor);
  else
    setcolor(0);
  if (mcolor%4==0)
    tc=15;
  else
    tc=4;
  switch(mdir){
    case 0:{rectangle(x-1,y-1,x+1,y+2);
	     setcolor(0);
	     line(x-1,y,x+1,y);
	     if (mrt) putpixel(x+1,y+2,tc);break;}
    case 3:{rectangle(x-2,y-1,x+1,y+1);
	     setcolor(0);
	     line(x,y-1,x,y+1);
	     if (mrt) putpixel(x-2,y+1,tc);break;}
    case 6:{rectangle(x-1,y-2,x+1,y+1);
	     setcolor(0);
	     line(x-1,y,x+1,y);
	     if (mrt) putpixel(x-1,y-2,tc);break;}
    case 9:{rectangle(x-1,y-1,x+2,y+1);
	     setcolor(0);
	     line(x,y-1,x,y+1);
	     if (mrt) putpixel(x+2,y-1,tc);break;}
  }
}


void CCar::State(){//sets states of Car and its transitions
  int flag=1;
  CStreet S;
  if((abs(mx-mdx)<25)&&(abs(my-mdy)<25))
    mst=0;
  else{
    LS.Init();
    while ((LS.GetPos())&&(flag)){//gets street in which the car is
      S=LS.GetNext();
      if (S.CarInStreet(* this))
	if (S.GetID()<5000){//if street is horizontal
	  if ((mdir==3)||(mdir==9))
	    flag=0;
	}
	else		    //street is vertical
	  if ((mdir==0)||(mdir==6))
	    flag=0;
    }

    if ((mv>=P.GetMinCV())&&(mv<=P.GetMaxCV())) ma=0;//cruise speed
    if ((mv<P.GetMinCV())&&(mv>0)) ma=0.5;  //in reality acceleration doesent turns from 0 to 0.5
    if (mv>P.GetMaxCV()) ma=-0.5; //instantly...

    CNear cn=C.CarNear(* this);
    if ((cn.car[0])){//checks if theres a car in front of him
      if ((S.Lane(*this)>=1)&&(S.Lane(*this)<S.GetLanes(*this))&&(!(cn.car[3]))&&(!mrt))
	S.IncLane(* this);
      else
	if(!(cn.car[2]))
	  if (mv>3)
	    ma=-3;
    }
    else{
      if (ma==-1)
	ma=0;
      if ((S.Lane(*this)>2)&&(!(cn.car[1]))&&(!mrt))
	S.DecLane(* this);
    }
    if ((S.Lane(*this)==1)&&(!(cn.car[3]))&&(!mrt))
      S.IncLane(*this);
  }
}

