//#include "clist.h"
//#include "ccar.h"
//#include "ccross.h"
#include "ccontrol.h"
#include <math.h>
#include <dos.h>
#include <graphics.h>
#include <stdlib.h>
//#include "cprobe.h"

CProbe P;
CControl C;
CList<CStreet> LS; //list of streets


void CControl::Report(CCar c){
  CCar caux;
  ml.Init();
  while (!(caux==c))
    caux=ml.GetNext();
  ml.SetNode(c);
}
CNear CControl::CarNear(CCar c){//tells the car if theres another car near him
  int rs=P.GetRs();//range to sides
  int rf=P.GetRf();//range forward and backward
  int dir=c.GetDir();
  float x=c.GetX();
  float y=c.GetY();
  CNear n;
  CCar caux;
  ml.Init();
  while (ml.GetPos()){
    caux=ml.GetNext();
    float ax=caux.GetX();
    float ay=caux.GetY();
    if (!(caux==c)){
      switch(dir){
	case 0: if ((abs(x-ax)<2)&&(0>y-ay)&&(y-ay>-rf)) n.car[2]=1;
		if ((abs(x-ax)<2)&&(0<y-ay)&&(y-ay<rf)) n.car[0]=1;
		if ((abs(y-ay)<rs)&&(0>x-ax)&&(x-ax>-5)) n.car[1]=1;
		if ((abs(y-ay)<rs)&&(0<x-ax)&&(x-ax<5)) n.car[3]=1;
		break;
	case 3: if ((abs(x-ax)<rs)&&(0>y-ay)&&(y-ay>-5)) n.car[1]=1;
		if ((abs(x-ax)<rs)&&(0<y-ay)&&(y-ay<5)) n.car[3]=1;
		if ((abs(y-ay)<2)&&(0>x-ax)&&(x-ax>-rf)) n.car[0]=1;
		if ((abs(y-ay)<2)&&(0<x-ax)&&(x-ax<rf)) n.car[2]=1;
		break;
	case 6: if ((abs(x-ax)<2)&&(0>y-ay)&&(y-ay>-rf)) n.car[0]=1;
		if ((abs(x-ax)<2)&&(0<y-ay)&&(y-ay<rf)) n.car[2]=1;
		if ((abs(y-ay)<rs)&&(0>x-ax)&&(x-ax>-5)) n.car[3]=1;
		if ((abs(y-ay)<rs)&&(0<x-ax)&&(x-ax<5)) n.car[1]=1;
		break;
	case 9: if ((abs(x-ax)<rs)&&(0>y-ay)&&(y-ay>-5)) n.car[3]=1;
		if ((abs(x-ax)<rs)&&(0<y-ay)&&(y-ay<5)) n.car[1]=1;
		if ((abs(y-ay)<2)&&(0>x-ax)&&(x-ax>-rf)) n.car[2]=1;
		if ((abs(y-ay)<2)&&(0<x-ax)&&(x-ax<rf)) n.car[0]=1;
		break;
      }
    }
  }
  return n;
}

int CControl::MegaNear(CCar c){//if there's a car 100m near, returns 1; otherwise, 0
  float x=c.GetX();
  float y=c.GetY();
  CCar caux;
  ml.Init();
  while (ml.GetPos()){
    caux=ml.GetNext();
    float ax=caux.GetX();
    float ay=caux.GetY();
    if (!(caux==c)){
      float d=sqrt(pow(ax-x,2)+pow(ay-y,2));
      if (d<100)
	return 1;
    }
  }
  return 0;
}


void CControl::Crash(CCar &c){//sees if car has crashed, notifies, and deactivates it;
  float x=c.GetX();
  float y=c.GetY();
  CCar caux;
  ml.Init();
  while (ml.GetPos()){
    caux=ml.GetNext();
    float ax=caux.GetX();
    float ay=caux.GetY();
    if (!(caux==c)){
      if((abs(x-ax)<4)&&(abs(y-ay)<4)){
	float d=sqrt(pow(ax-x,2)+pow(ay-y,2));
	if ((d<4)&&(c.GetSt())){//car crash
	  char cad[10];
	  setcolor(4);
	  circle((x+P.GetX())/P.GetSc(),(y+P.GetY())/P.GetSc(),5);
	  sound(50);
	  if (!P.GetDly())
	    outtextxy(0,340,"Press any key to continue...");
	  outtextxy(0,(20*P.mcrshcnt),"Crashed car: ");
	  itoa(c.GetID(), cad, 10);
	  outtextxy(100,(20*P.mcrshcnt),cad);
	  outtextxy(0,10+(20*P.mcrshcnt),"at: ");
	  itoa(c.GetX(), cad, 10);
	  outtextxy(30,10+(20*P.mcrshcnt),cad);
	  itoa(c.GetY(), cad, 10);
	  outtextxy(80,10+(20*P.mcrshcnt),cad);
	  P.mcrshflg=1;
	  P.mcrshcnt++;
	  delay(100);
	  nosound();
	  c.SetSt(0);//deactivates car
	  P.mcrsh++;
	  Report(c);
	}
      }
    }
  }
}