//#include "clist.h"
//#include "ccar.h"
#include <math.h>
//#include "ccross.h"
#include "ccontrol.h"
//#include "cprobe.h"

extern CProbe P;
extern CControl C;
extern CList<CStreet> LS; //list of streets

unsigned long CCross::t=0;//time;
		  //in reality, it isnt discrete

void CCross::State(CCar &c){//sets states of Cross and its transitions
			   //call it after CCar::State()
			   //(the Cross must overrule the car)
			   //but before CCar::Trans()

  int range=P.GetRg();//range of CCross (in meters)

  float x=c.GetX();
  float y=c.GetY();
  float v=c.GetV();
  float a=c.GetA();
  int dir=c.GetDir();
  int id=c.GetID();
  float db,d;//calculates distance to car
  CReg reg;
  reg.id=id;
  lreg-reg;
  int approach=0;
  switch(dir){       //checks if car is approaching
	case 0:if((my1+range>y)&&(y>my1)&&(mx1<x)&&(x<mx2))
	  approach=1; db=y-my2; break;
	case 3:if((mx2-range<x)&&(x<mx2)&&(my1<y)&&(y<my2))
	  approach=1; db=mx1-x; break;
	case 6:if((my2-range<y)&&(y<my2)&&(mx1<x)&&(x<mx2))
	  approach=1; db=my1-y; break;
	case 9:if((mx1+range>x)&&(x>mx1)&&(my1<y)&&(y<my2))
	  approach=1; db=x-mx2; break;
  }
  if (approach){
    int flag=1;
    CStreet S;
    LS.Init();
    while ((LS.GetPos())&&(flag)){//gets street in which the car is
      S=LS.GetNext();
      if (S.CarInStreet(c))
	if (S.GetID()<5000){//if street is horizontal
	  if ((dir==3)||(dir==9))
	    flag=0;
	}
	else		    //street is vertical
	  if ((dir==0)||(dir==6))
	    flag=0;
    }
    CNear cn=C.CarNear(c);
    if (RightTurn(c)){
      c.SetRt(1);
      if ((S.Lane(c)>1)&&(!(cn.car[1])))
	S.DecLane(c);
      cn=C.CarNear(c);
      if ((S.Lane(c)>1)&&(!(cn.car[1])))
	S.DecLane(c);
      cn=C.CarNear(c);
      if ((db<=100)&&(v>10))
	a=-3;
      if ((S.Lane(c)==1)&&(cn.car[0])&&(!(cn.car[2])))
	if (v>3)
	  a=-3;
      if (v<=3) a=0;
      if ((CarInCross(c))||(v>db)){//turn right the car
	switch (dir){
	  case 0:c.SetX(mx2);c.SetY(my2-2);c.SetDir(3);break;
	  case 3:c.SetX(mx1+2);c.SetY(my2);c.SetDir(6);break;
	  case 6:c.SetX(mx1);c.SetY(my1+2);c.SetDir(9);break;
	  case 9:c.SetX(mx2-2);c.SetY(my1);c.SetDir(0);break;
	}
	c.SetRt(0);
      }
    }
    else{
      if ((S.Lane(c)==1)&&(cn.car[0])&&(!(cn.car[2]))){
	if (v>3)
	  a=-3;
	if (v<=3) a=0;
      }
      else{
	int ok=0; //flag
	float ind=0;//index to adjust speed
	while (!ok){
	  d=db;
	  v=c.GetV();
	  a=c.GetA()-ind;
	  if (v<1) v=1;
	  reg.t1=t;//start timer
	  while (d>0){
	    if ((v>=P.GetMinCV())&&(v<=P.GetMaxCV())) a=0-ind;//cruise speed
	    if ((v<P.GetMinCV())&&(v>0)) a=0.5-ind;  //in reality acceleration doesent turns from 0 to 0.5
	    if (v>P.GetMaxCV()) a=-0.5-ind; //instantly...
	    v=v+a;//apply acceleration to velocity (even if a=0)
	    d=d-v;
	    reg.t1++;
	  }
	  switch (dir){
	    case 0:reg.x1=x-2;reg.x2=x+2;
		   reg.y1=my1;reg.y2=my2;
		   reg.t2=reg.t1+(my2-my1)/v;
		   break;
	    case 3:reg.x1=mx1;reg.x2=mx2;
		   reg.y1=y-2;reg.y2=y+2;
		   reg.t2=reg.t1+(mx2-mx1)/v;
		   break;
	    case 6:reg.x1=x-2;reg.x2=x+2;
		   reg.y1=my1;reg.y2=my2;
		   reg.t2=reg.t1+(my2-my1)/v;
		   break;
	    case 9:reg.x1=mx1;reg.x2=mx2;
		   reg.y1=y-2;reg.y2=y+2;
		   reg.t2=reg.t1+(mx2-mx1)/v;
		   break;
	  }
	  a=c.GetA()-ind;
	  ind+=0.05;
	  ok=1;
	  lreg.Init();
	  while(lreg.GetPos()){
	    CReg reg2=lreg.GetNext();
	    if (reg && reg2/*lreg.GetNext()*/) ok=0;//sees if the area that car is going to use
	  }                                 //is aviable at the time car is at CCross
	  if (ind>=1){//prevents loops
	    ok=1;
	    if (v>3)
	      a=-3;
	    if (v<=3) a=0;
	  }
	}
	lreg+reg;
      }
    }
    c.SetA(a);
  }
}

int CCross::RightTurn (CCar c){//If car is going to turn right on cross,
			       //returns 1, otherwise, 0

  int range=P.GetRg();//range of CCross (in meters)
  float x=c.GetX();
  float y=c.GetY();
  float dx=c.GetDX();
  float dy=c.GetDY();
  int dir=c.GetDir();
  int approach=0;
  switch(dir){       //checks if car is approaching
	case 0:if((my1+range>y)&&(y>my1)&&(mx1<x)&&(x<mx2)) approach=1; break;
	case 3:if((mx2-range<x)&&(x<mx2)&&(my1<y)&&(y<my2)) approach=1; break;
	case 6:if((my2-range<y)&&(y<my2)&&(mx1<x)&&(x<mx2)) approach=1; break;
	case 9:if((mx1+range>x)&&(x>mx1)&&(my1<y)&&(y<my2)) approach=1; break;
  }
  if (approach){
    switch (dir){
      case 0: if((mdirs[1])&&((dy>my2)||((my1<dy)&&(dy<my2)&&(dx>mx2)))) return 1;break;
      case 3: if((mdirs[2])&&((dx<mx1)||((mx1<dx)&&(dx<mx2)&&(dy>my2)))) return 1;break;
      case 6: if((mdirs[3])&&((dy<my1)||((my1<dy)&&(dy<my2)&&(dx<mx1)))) return 1;break;
      case 9: if((mdirs[0])&&((dx>mx2)||((mx1<dx)&&(dx<mx2)&&(dy<my1)))) return 1;break;
    }
  }
  return 0;
}

