#include <conio.h>
#include <graphics.h>
#include <dos.h>
#include <stdlib.h>
//#include "ccross.h"
//#include "ccontrol.h"


class CProbe{
float msc;//scale(1 pixel=scale meters)
int mx,my,//coords of center of scope
       mrg,//range of CCross
       mrs,//range on side lanes
       mrf,//range on car lane       these last 2 recommended to be equal
       mcr,//random car creation rate (1 car each mcr seconds)
       mcrshdly;//flag for delay in notifying car crash
float  mmaxcv,//max cruise velocity (m/s)
       mmincv;//min cruise velocity (m/s)

public:
int macars,//active cars
    mtcars,//total cars
    mcrsh,//crashed cars
    mcrshflg,//crash flag
    mcrshcnt,//crash counter
    mt;//time
float mavgv,//average speed
      mavga;//average acceleration

CProbe(){
  msc=5;mx=-5900;my=-4300;mt=macars=mtcars=mcrsh=mcrshflg=mcrshcnt=mavgv=mavga=0;
  mrg=300;mrs=mrf=50;mmaxcv=19;mmincv=16;mcr=50;mcrshdly=0;
}
float GetSc() {return msc;}
int GetRg() {return mrg;}
int GetRs() {return mrs;}
int GetRf() {return mrf;}
int GetX() {return mx;}
int GetY() {return my;}
int GetCarRate() {return mcr;}
int GetDly() {return mcrshdly;}
float GetMaxCV() {return mmaxcv;}
float GetMinCV() {return mmincv;}
void SetSc(float sc) {
  msc=sc;
  if (msc<0.001)msc=0.001;
  char cad[10];
  setcolor(9);
  outtextxy(0,getmaxy()-7,"Scale: 1 pixel :");
  gcvt(msc,7, cad);
  outtextxy(130,getmaxy()-7,cad);
  delay(250);
}
void SetRg(int rg) {
  mrg=rg;
  if (mrg<0)mrg=0;
  char cad[10];
  setcolor(9);
  outtextxy(0,getmaxy()-7,"Cross' range: ");
  itoa(mrg, cad, 10);
  outtextxy(110,getmaxy()-7,cad);
  delay(250);
}
void SetRs(int rs) {
  mrs=rs;
  if (mrs<0)mrs=0;
  char cad[10];
  setcolor(9);
  outtextxy(0,getmaxy()-7,"Car's side lane range: ");
  itoa(mrs, cad, 10);
  outtextxy(180,getmaxy()-7,cad);
  delay(250);
}
void SetRf(int rf) {
  mrf=rf;
  if (mrf<0)mrf=0;
  char cad[10];
  setcolor(9);
  outtextxy(0,getmaxy()-7,"Car's current lane range: ");
  itoa(mrf, cad, 10);
  outtextxy(200,getmaxy()-7,cad);
  delay(250);
}
void SetCarRate(int cr) {
  mcr=cr;
  if (mcr<1)mcr=1;
  else
    if (mcr%10!=0) mcr--;

  char cad[10];
  setcolor(9);
  if (mcr<1000){
  outtextxy(0,getmaxy()-7,"New car every: ");
  itoa(mcr, cad, 10);
  outtextxy(115,getmaxy()-7,cad);
  }
  else
    outtextxy(0,getmaxy()-7,"No new cars");
  delay(250);
}
void SetDly(int dly) {
  mcrshdly=dly;
  setcolor(9);
  if (dly)
    outtextxy(0,getmaxy()-7,"Crash delay on");
  else
    outtextxy(0,getmaxy()-7,"Crash delay off");
  delay(250);
}
void SetXY(int x,int y){
  mx=x;my=y;
  char cad[10];
  setcolor(9);
  outtextxy(0,getmaxy()-7,"Scope: ");
  itoa(mx, cad, 10);
  outtextxy(60,getmaxy()-7,cad);
  itoa(my, cad, 10);
  outtextxy(110,getmaxy()-7,cad);
  delay(250);

}
void SetMaxCV(float v){
  mmaxcv=v;
  if (mmaxcv<=mmincv)mmaxcv=mmincv+1;
  char cad[10];
  setcolor(9);
  outtextxy(0,getmaxy()-7,"Maximum Cruise Velocity:");
  gcvt(mmaxcv,7, cad);
  outtextxy(200,getmaxy()-7,cad);
  delay(250);
}
void SetMinCV(float v){
  mmincv=v;
  if (mmincv>=mmaxcv)mmincv=mmaxcv-1;
  char cad[10];
  setcolor(9);
  outtextxy(0,getmaxy()-7,"Minimum Cruise Velocity:");
  gcvt(mmincv,7, cad);
  outtextxy(200,getmaxy()-7,cad);
  delay(250);
}
void Stat(){
  char cad[20];
  setcolor(9);
  outtextxy(300,0,"CRASH");
  outtextxy(145,10,"Car and Road Automated Simulation in Hyperways");
  outtextxy(204,20,"Gershenson Tecnologies Inc. 1998");

  outtextxy(0,50, "Simulation Paused...");
  outtextxy(0,70,"Total Cars :");
  itoa(mtcars, cad, 10);
  outtextxy(100,70,cad);
  outtextxy(0,80,"Active Cars :");
  itoa(macars, cad, 10);
  outtextxy(107,80,cad);
  outtextxy(0,90,"Crashed Cars :");
  itoa(mcrsh, cad, 10);
  outtextxy(115,90,cad);
  outtextxy(0,100,"Average Cars Velocity :");
  gcvt(mavgv,7, cad);
  outtextxy(190,100,cad);
  outtextxy(0,110,"Average Cars Acceleration :");
  gcvt(mavga,7, cad);
  outtextxy(220,110,cad);
  outtextxy(0,140,"Cross' range: ");
  itoa(mrg, cad, 10);
  outtextxy(110,140,cad);
  outtextxy(0,150,"Car's side lane range: ");
  itoa(mrs, cad, 10);
  outtextxy(180,150,cad);
  outtextxy(0,160,"Car's current lane range: ");
  itoa(mrf, cad, 10);
  outtextxy(200,160,cad);
  outtextxy(0,170,"Maximum Cruise Velocity:");
  gcvt(mmaxcv,7, cad);
  outtextxy(200,170,cad);
  outtextxy(0,180,"Minimum Cruise Velocity:");
  gcvt(mmincv,7, cad);
  outtextxy(200,180,cad);
  if (mcr<1000){
    outtextxy(0,190,"New car every: ");
    itoa(mcr, cad, 10);
    outtextxy(115,190,cad);
  }
  else
    outtextxy(0,190,"No new cars");
  if (mcrshdly)
    outtextxy(0,210,"Crash delay on");
  else
    outtextxy(0,210,"Crash delay off");
  outtextxy(0,230,"Scope: ");
  itoa(mx, cad, 10);
  outtextxy(60,230,cad);
  itoa(my, cad, 10);
  outtextxy(110,230,cad);
  outtextxy(0,240,"Scale: 1 pixel :");
  gcvt(msc,7, cad);
  outtextxy(130,240,cad);

  outtextxy(0,300,"Seconds: ");
  ltoa(mt, cad, 10);
  outtextxy(70,300,cad);

  outtextxy(0,getmaxy()-7,"Press any key to return to CRASH");
  getch();
}
void Help(){
  setcolor(9);
  outtextxy(300,0,"CRASH");
  outtextxy(145,10,"Car and Road Automated Simulation in Hyperways");
  outtextxy(204,20,"Gershenson Tecnologies Inc. 1998");

  outtextxy(0,50, "Simulation Paused...");
  outtextxy(0,70, "Move scope with arrows.");
  outtextxy(0,80, "Ins - Zoom Out (+)");
  outtextxy(0,90, "Del - Zoom In  (-)");
  outtextxy(0,100,"PgUp - Zoom Out (*)");
  outtextxy(0,110,"PgDn - Zoom In  (/)");
  outtextxy(0,120,"Home - Scale = 20");
  outtextxy(0,130,"End - Center scope");
  outtextxy(0,140,"o - Increases Cross' ranges");
  outtextxy(0,150,"l - Decreases Cross' ranges");
  outtextxy(0,160,"i - Increases car's  ranges on side lanes");
  outtextxy(0,170,"k - Decreases car's  ranges on side lanes");
  outtextxy(0,180,"u - Increases car's  ranges on current lane");
  outtextxy(0,190,"j - Decreases car's  ranges on current lane");
  outtextxy(0,200,"y - Increases car's  maximum cruise velocity");
  outtextxy(0,210,"h - Decreases car's  maximum cruise velocity");
  outtextxy(0,220,"t - Increases car's  minimum cruise velocity");
  outtextxy(0,230,"g - Decreases car's  minimum cruise velocity");
  outtextxy(0,240,"r - Increases new cars");
  outtextxy(0,250,"f - Decreases new cars");
  outtextxy(0,260,"v - No new cars");
  outtextxy(0,270,"m - Toggle crash delay");

  outtextxy(0,290,"s - Simulation Statistics");

  outtextxy(0,300,"a - Pause (this screen)");
  outtextxy(0,320,"Esc - Exit CRASH");

  outtextxy(0,getmaxy()-7,"Press any key to return to CRASH");

  getch();
}

};

