#include "cprobe.h"
#include "ccar.h"
#include <graphics.h>

extern CProbe P;

class CStreet{
int mx1,my1,mx2,my2,//coords of street
		mdir1,//allowed directions (0,3). -1 if none of the above
		mdir2,//allowed directions (6,9). -1 if none of the above
		      //0 and 6 , 3 and 9, obviously
		mln1,//number of lanes on dir1
		mln2,//number of lanes on dir2
		//each lane must be 4 m wide
		mid;//Street ID. 3XXX if horizontal, 6XXX if vertical

public:

CStreet()
  {mx1=my1=mx2=my2=mln1=mln2=0;mdir1=mdir2=mid=-1;}
CStreet(int x1,int y1,int x2,int y2,int d1,int d2,int l1,int l2,int id)
  {mx1=x1;my1=y1;mx2=x2;my2=y2;mdir1=d1;mdir2=d2;mln1=l1;mln2=l2;mid=id;}
void Set(int x1,int y1,int x2,int y2,int d1,int d2,int l1,int l2,int id)
  {mx1=x1;my1=y1;mx2=x2;my2=y2;mdir1=d1;mdir2=d2;mln1=l1;mln2=l2;;mid=id;}
int GetID(){return mid;}
int GetX1(){return mx1;}
int GetY1(){return my1;}
int GetX2(){return mx2;}
int GetY2(){return my2;}
int GetDir1(){return mdir1;}
int GetDir2(){return mdir2;}


friend int operator ==(CStreet s1,CStreet s2){
    if(s1.GetID()==s2.GetID())
      return 1;
    else
      return 0;
  }
void Draw(){
  int x1=(mx1+P.GetX())/P.GetSc(),y1=(my1+P.GetY())/P.GetSc(),
      x2=(mx2+P.GetX())/P.GetSc(),y2=(my2+P.GetY())/P.GetSc();
  setcolor(8);
  if ((mdir1>=0)&&(mdir2>=0))
    if (mdir1==0)
      line(x1+(4*mln2/P.GetSc()),y1,x1+(4*mln2/P.GetSc()),y2);
    else
      line(x1,y1+(4*mln2/P.GetSc()),x2,y1+(4*mln2/P.GetSc()));
  setcolor(15);
  line(x1,y1,x2,y1);
  line(x1,y2,x2,y2);
  line(x1,y1,x1,y2);
  line(x2,y1,x2,y2);
}
int CarInStreet(CCar c){//tells if car is in the street
  if ((mx1<=c.GetX())&&(mx2>=c.GetX())&&(my1<=c.GetY())&&(my2>=c.GetY()))
    return 1;
  else
    return 0;
}

int Lane(CCar c);//tells in what lane the car is (from right to left)
int GetLanes(CCar c);//tells # of lanes on the street and direction the car is going
void IncLane(CCar &c);//car moves 1 lane left (if possible)
void DecLane(CCar &c);//car moves 1 lane right (if possible)

};